//+------------------------------------------------------------------+
//|                                               DoublecciWoody.mq4 |
//|
//+------------------------------------------------------------------+
#property copyright " DoublecciWoody."
#property link      "DoublecciWoody"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 MediumSeaGreen   //Green
#property indicator_color2 Red   //SaddleBrown
#property indicator_color3 DarkGray
#property indicator_color4 Gold
#property indicator_color5 DarkKhaki //White
#property indicator_color6 White  //Magenta
#property indicator_color7 DarkKhaki  //Gold  <<<<<<<<<<<<<<<<<<<<<<<<<<
#property indicator_level1 350
#property indicator_level2 250
#property indicator_level3 100
#property indicator_level4 0
#property indicator_level5 -100
#property indicator_level6 -250
#property indicator_level7 -350
//#property indicator_level8 -50

//---- input parameters
extern string  TimeFrame        = "10080";
extern int TrendCCI_Period = 14;//14
extern int EntryCCI_Period = 6;//6
extern int Trend_period = 2;//6
extern int  CountBars=1000; 
extern bool Zero_Cross_Alert;

extern int   LineSize1=0;
extern int   LineSize2=0;
extern int   LineSize3=0;//1
extern bool   ShowLines = true;
extern bool   ShowArrows       = true;
extern double arrowsUpperGap   = 0.3;
extern double arrowsLowerGap   = 0.3;
extern color  arrowsUpColor    = Yellow;
extern color  arrowsDnColor    = Magenta;
extern int    arrowsUpCode     = 233;
extern int    arrowsDnCode     = 234;
extern int    arrowsUpSize     = 3;
extern int    arrowsDnSize     = 3;

string arrowsIdentifier;
double TrendCCI[];
double EntryCCI[];
double CCITrendUp[];
double CCITrendDown[];
double CCINoTrend[];
double CCITimeBar[];
double ZeroLine[];
double trend[];

int trendUp, trendDown;
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()  {
   arrowsIdentifier = StringConcatenate("dcci_Arrows2_",StrRand(6));
   IndicatorBuffers(8);
   SetIndexStyle(4, DRAW_LINE, STYLE_SOLID,LineSize1);
   SetIndexBuffer(4, TrendCCI);
   SetIndexLabel(4, "TrendCCI");
   SetIndexStyle(0, DRAW_HISTOGRAM, 0,LineSize1);//2
   SetIndexBuffer(0, CCITrendUp);
   SetIndexStyle(1, DRAW_HISTOGRAM, 0,LineSize1);//2
   SetIndexBuffer(1, CCITrendDown);
   SetIndexStyle(2, DRAW_HISTOGRAM, 0,LineSize2);
   SetIndexBuffer(2, CCINoTrend);
   SetIndexStyle(3, DRAW_HISTOGRAM, 0,LineSize2);
   SetIndexBuffer(3, CCITimeBar);
   SetIndexStyle(5, DRAW_LINE, STYLE_SOLID,LineSize2);// 1 <<<<<<<<<<<<<<<<<<<<<<<<<<<
   SetIndexBuffer(5, EntryCCI);
   SetIndexLabel(5, "EntryCCI");
   SetIndexStyle(6, DRAW_LINE, STYLE_SOLID,LineSize3);
   SetIndexBuffer(6, ZeroLine);
   SetIndexBuffer(7, trend);
   SetIndexLabel(7, "Trend"); 
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
      IndicatorShortName("(TrendCCI: " + TrendCCI_Period + ", EntryCCI: " + EntryCCI_Period + ") ");   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   deleteArrows(); 
   deleteLines();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()    
{
int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { CCITrendUp[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);   
                      CCITrendUp[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TrendCCI_Period,EntryCCI_Period,Trend_period,CountBars,Zero_Cross_Alert,0,y);
                      CCITrendDown[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TrendCCI_Period,EntryCCI_Period,Trend_period,CountBars,Zero_Cross_Alert,1,y);
                      CCINoTrend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TrendCCI_Period,EntryCCI_Period,Trend_period,CountBars,Zero_Cross_Alert,2,y);
                      CCITimeBar[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TrendCCI_Period,EntryCCI_Period,Trend_period,CountBars,Zero_Cross_Alert,3,y);
                      TrendCCI[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TrendCCI_Period,EntryCCI_Period,Trend_period,CountBars,Zero_Cross_Alert,4,y);
                      EntryCCI[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TrendCCI_Period,EntryCCI_Period,Trend_period,CountBars,Zero_Cross_Alert,5,y);
                      ZeroLine[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TrendCCI_Period,EntryCCI_Period,Trend_period,CountBars,Zero_Cross_Alert,6,y);
               }
               return(0);
            }
static datetime prevtime = 0;
   int trendCCI, entryCCI;
   counted_bars = IndicatorCounted();
//---- check for possible errors
   
     SetIndexDrawBegin(0,Bars-CountBars);
     SetIndexDrawBegin(1,Bars-CountBars);
     SetIndexDrawBegin(2,Bars-CountBars);
     SetIndexDrawBegin(3,Bars-CountBars);
     SetIndexDrawBegin(4,Bars-CountBars);
     SetIndexDrawBegin(5,Bars-CountBars);
     SetIndexDrawBegin(6,Bars-CountBars);
   

      trendCCI = TrendCCI_Period;
      entryCCI = EntryCCI_Period;
   IndicatorShortName(timeFrameToString(timeFrame)+" (TrendCCI: " + trendCCI + ", EntryCCI: " + entryCCI + ") "); 
   for(i = limit; i >= 0; i--) {
      CCINoTrend[i] = 0;
      CCITrendDown[i] = 0;
      CCITimeBar[i] = 0;
      CCITrendUp[i] = 0;
      ZeroLine[i] = 0;
      TrendCCI[i] = iCCI(NULL, 0, trendCCI, PRICE_TYPICAL, i);
      EntryCCI[i] = iCCI(NULL, 0, entryCCI, PRICE_TYPICAL, i);
      
      if(TrendCCI[i] > 0 && TrendCCI[i+1] < 0) {
         if (trendDown >  Trend_period) trendUp = 0;
      }
      if (TrendCCI[i] > 0) {
         if (trendUp <  Trend_period){
            CCINoTrend[i] = TrendCCI[i];
            trendUp++;
         }
         if (trendUp ==  Trend_period) {
            CCITimeBar[i] = TrendCCI[i];
            trendUp++;
         }
         if (trendUp >  Trend_period) {
            CCITrendUp[i] = TrendCCI[i];
         }
      }
      if(TrendCCI[i] < 0 && TrendCCI[i+1] > 0) {
         if (trendUp >  Trend_period) trendDown = 0;
      }
      if (TrendCCI[i] < 0) {
         
         if (trendDown <  Trend_period){
            CCINoTrend[i] = TrendCCI[i];
            trendDown++;
         }
         if (trendDown ==  Trend_period) {
            CCITimeBar[i] = TrendCCI[i];
            trendDown++;
         }
         if (trendDown >  Trend_period) {
            CCITrendDown[i] = TrendCCI[i];
         }
      }
      trend[i] = 0;
      if (EntryCCI[i]>ZeroLine[i]) trend[i] = 1;
      if (EntryCCI[i]<ZeroLine[i]) trend[i] =-1;
      
            
      if(true)
      {         
         //deleteArrow(Time[i]);
     
         if(trend[i] != trend[i+1])
         {
            if (trend[i] == 1)  {
               if(ShowArrows) drawArrow(i,arrowsUpColor,arrowsUpCode,false);
               if(ShowLines) drawLine(i,arrowsUpColor,2);
            }
            if (trend[i] ==-1)  {
               if(ShowArrows) drawArrow(i,arrowsDnColor,arrowsDnCode, true);
               if(ShowLines) drawLine(i,arrowsDnColor,2);
            }
         }
      } 
   }
   
   if (Zero_Cross_Alert == true) {
      if (prevtime == Time[0]) {
         return(0);
      }
      else {
         if(EntryCCI[0] < 0) {
            if((TrendCCI[0] < 0) && (TrendCCI[1] >= 0)) {
               Alert(Symbol(), " M", Period(), " Trend & Entry CCI Have both crossed below zero");
            }
         }
         else if(EntryCCI[0] > 0) {
            if((TrendCCI[0] > 0) && (TrendCCI[1] <= 0)) {
               Alert(Symbol(), " M", Period(), " Trend & Entry CCI Have both crossed above zero");
            }
         }
         prevtime = Time[0];
      }
   }
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

void drawLine(int i,color theColor,int theWidth)
{
   string name = "decci_Lines:"+Time[i];

   ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
   ObjectSet(name,OBJPROP_COLOR,theColor);
   ObjectSet(name,OBJPROP_WIDTH,theWidth);
   ObjectSet(name,OBJPROP_BACK,true);
}

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
      ObjectSet(name,OBJPROP_ARROWCODE,theCode);
      ObjectSet(name,OBJPROP_COLOR,theColor);
      if (up) ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
      else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

void deleteLines()
{
   string lookFor       = "decci_Lines:";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}
string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

string StrRand(int length)
{
   string output = "";
   int num; 
   
   for(int i=0;i<length;i++) {
      num = 25*rand()/32768+97;
     
      output = StringConcatenate(output,CharToStr((uchar)num));
   }
   
   return(output);
}